unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, Forms, StdCtrls, LResources;

type

  TClass2 = class;

  { TClass1 }

  TClass1 = class (TComponent)
  private
    FValue1: Integer;
    FClass2: TClass2;
    function GetValue2: Integer;
    procedure SetValue1(AValue: Integer);
    procedure SetValue2(AValue: Integer);
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Value1: Integer read FValue1 write SetValue1;
    property Value2: Integer read GetValue2 write SetValue2;
  end;

  { TClass2 }

  TClass2 = class (TComponent)
  private
    FValue2: Integer;
    procedure SetValue2(AValue: Integer);
  published
    property Value2: Integer read FValue2 write SetValue2;
  end;

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
      AClass1: TClass1;
      AClass2: TClass2;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  AClass1 := TClass1.Create(Self);
  AClass2 := TClass2.Create(AClass1);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  AStream: TMemoryStream;
begin
  AStream := TMemoryStream.Create;
  try
    WriteComponentAsTextToStream(AStream, AClass1);
    AStream.SaveToFile('Class1.txt');
  finally
    AStream.Free;
  end;
end;

{ Class2 }

procedure TClass2.SetValue2(AValue: Integer);
begin
  if FValue2=AValue then Exit;
  FValue2:=AValue;
end;

procedure TClass1.SetValue1(AValue: Integer);
begin
  if FValue1=AValue then Exit;
  FValue1:=AValue;
end;

function TClass1.GetValue2: Integer;
begin
  Result:=FClass2.Value2;
end;

procedure TClass1.SetValue2(AValue: Integer);
begin
  if FClass2.FValue2 <> AValue then
    FClass2.FValue2 := AValue;
end;

constructor TClass1.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FClass2:=TClass2.Create(Self);
end;

end.

